From ee20544e01f75ceae26588b9531f7cfeaaa032f7 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 21 2020 04:41:32 +0000
Subject: [PATCH 1751/2232] Merge trivial detection loops over function apis


---

diff --git a/syntax/types.rs b/syntax/types.rs
index fa027eb..173610d 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -192,10 +192,27 @@ impl<'a> Types<'a> {
                     }
                 }
                 Api::CxxFunction(efn) | Api::RustFunction(efn) => {
+                    if let Some(receiver) = &efn.receiver {
+                        if receiver.mutable && !receiver.pinned {
+                            let reason = TrivialReason::UnpinnedMutArg(efn);
+                            insist_extern_types_are_trivial(&receiver.ty, reason);
+                        }
+                    }
                     for arg in &efn.args {
-                        if let Type::Ident(ident) = &arg.ty {
-                            let reason = TrivialReason::FunctionArgument(efn);
-                            insist_extern_types_are_trivial(ident, reason);
+                        match &arg.ty {
+                            Type::Ident(ident) => {
+                                let reason = TrivialReason::FunctionArgument(efn);
+                                insist_extern_types_are_trivial(ident, reason);
+                            }
+                            Type::Ref(ty) => {
+                                if ty.mutable && !ty.pinned {
+                                    if let Type::Ident(ident) = &ty.inner {
+                                        let reason = TrivialReason::UnpinnedMutArg(efn);
+                                        insist_extern_types_are_trivial(ident, reason);
+                                    }
+                                }
+                            }
+                            _ => {}
                         }
                     }
                     if let Some(ret) = &efn.ret {
@@ -225,29 +242,6 @@ impl<'a> Types<'a> {
                 _ => {}
             }
         }
-        for api in apis {
-            match api {
-                Api::CxxFunction(efn) | Api::RustFunction(efn) => {
-                    if let Some(receiver) = &efn.receiver {
-                        if receiver.mutable && !receiver.pinned {
-                            let reason = TrivialReason::UnpinnedMutArg(efn);
-                            insist_extern_types_are_trivial(&receiver.ty, reason);
-                        }
-                    }
-                    for arg in &efn.args {
-                        if let Type::Ref(reff) = &arg.ty {
-                            if reff.mutable && !reff.pinned {
-                                if let Type::Ident(ident) = &reff.inner {
-                                    let reason = TrivialReason::UnpinnedMutArg(efn);
-                                    insist_extern_types_are_trivial(ident, reason);
-                                }
-                            }
-                        }
-                    }
-                }
-                _ => {}
-            }
-        }
 
         let mut types = Types {
             all,

